%undefine _missing_build_ids_terminate_build
%global _unpackaged_files_terminate_build 1

%if %{defined _project}
# define if building on openSUSE build service
%global build_on_obs       1
%else
%define _project           local
%global build_on_obs       0
%global _hardened_build    1
%endif

%global xxxxbug            1
%if %{defined nodebug}
%global debug_package      %{nil}
%endif
%global _prefix            /usr

%if 0%{?suse_version}
%global dist suse
%global disttag suse
%endif

%if 0%{?fedora_version}
%global dist %{?dist}
%global disttag fedora
%endif

Summary: Utilities for Safe Banking
Name: svcron
Version: 1.0
Release: 1.1%{?dist}
%if %build_on_obs == 1
License: GPL-3.0+
%else
License: GPLv3
%endif
Group: System Environment/Base
Requires: rpm
BuildRequires: gcc libqmail-devel autoconf automake libtool sed m4
Source0: http://downloads.sourceforge.net/indimail/%{name}-%{version}.tar.gz
URL: https://github.com/indimail/svcron

%description
svcron is a daemon that runs specified programs at scheduled times. This
package contains Paul Vixie's implementation of cron

%prep
%setup -q

%build
%{__mkdir_p} m4
aclocal -I m4
autoreconf -fis
%configure --prefix=%{_prefix} \
  --enable-crondir=%{_sysconfdir}/indimail/cron \
  --enable-spooldir=crontabs \
  --enable-syscrondir=%{_sysconfdir}/indimail/cron.d \
  --enable-syscrontab=%{_sysconfdir}/indimail/crontab \
  --mandir=%{_prefix}/share/man

%install
%{__make} %{?_smp_mflags}
%if %{defined nodebug}
  %{__make} %{?_smp_mflags} DESTDIR=%{buildroot} install-strip
%else
  %{__make} %{?_smp_mflags} DESTDIR=%{buildroot} install
%endif
%{__mkdir_p} %{buildroot}%{_sysconfdir}/indimail/cron
%{__mkdir_p} %{buildroot}%{_sysconfdir}/indimail/cron/crontabs
%{__mkdir_p} %{buildroot}%{_sysconfdir}/indimail/cron.d
%if %{undefined nodebug}
  /bin/chmod -R 755 %{buildroot}%{_prefix}/bin
%endif

%files
%defattr(-, root, root,-)
%attr(755,root,root)                    %{_prefix}/sbin/svcron
%attr(755,root,root)                    %{_prefix}/bin/svcrontab
%dir        %attr(700,root,root )       %{_sysconfdir}/indimail/cron
%dir        %attr(700,root,root )       %{_sysconfdir}/indimail/cron/crontabs
%if %{undefined suse_version} && %{undefined sles_version}
%ghost      %attr(700,root,root )       %{_sysconfdir}/indimail/cron/crontabs/*
%else
%endif
%if %{defined suse_version} && %{defined sles_version}
%dir        %attr(755,root,root )       %{_sysconfdir}/indimail
%endif
            %attr(755,root,root )       %{_sysconfdir}/indimail/crontab
%dir        %attr(755,root,root )       %{_sysconfdir}/indimail/cron.d
%dir        %attr(755,root,root )       %{_prefix}/share/doc/svcron

%doc        %attr(644,root,root)        %{_prefix}/share/man/man1/*
%doc        %attr(644,root,root)        %{_prefix}/share/man/man5/*
%doc        %attr(644,root,root)        %{_prefix}/share/man/man8/*
%if %build_on_obs == 0
%license    %attr(0644,root,root)       %{_prefix}/share/doc/%{name}/LICENSE
%else
%attr(0644,root,root)                   %{_prefix}/share/doc/%{name}/LICENSE
%endif
%attr(0644,root,root)                   %{_prefix}/share/doc/%{name}/AUTHORS
%attr(0644,root,root)                   %{_prefix}/share/doc/%{name}/ChangeLog

%changelog
* Thu Jun 13 2024 15:26:20 +0000 Manvendra Bhangui <svcron@indimail.org> 1.0-1.1%{?dist}
Release 1.0-1.1 Start 04/06/2024 End XX/XX/XXXX
- First Version
- Bug fixes
- made CRON_ALLOW, CRON_DENY absolute
